package cn.com.qmth.stmms.ms.commons.constant;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * @Description: 仲裁自动打回算法
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2019/11/6
 */
public class ArbitrateCallback {
    private static Logger LOGGER = LoggerFactory.getLogger(ArbitrateCallback.class);

    public static char[] LEVELS = new char[5];//各评卷员评选的档位数组

    public static int MAX_DISTANCE = 2 //仲裁档位
            , SUM_DISTANCE = 2 * 2 + 1;//最大落差档位和

    /**
     * 自动打回算法
     *
     * @param levelList
     * @param maxDistance
     * @return
     */
    public static List<String> judge(List<String> levelList, int maxDistance) {
        MAX_DISTANCE = maxDistance;
        SUM_DISTANCE = MAX_DISTANCE * 2 + 1;
        List<String> resultList = null;
        Collections.sort(levelList);
        for (int i = 0; i < levelList.size(); i++) {
            LEVELS[i] = levelList.get(i).charAt(0);
        }
        List<Distance> result = judge(LEVELS);
        if (Objects.nonNull(result)) {
            resultList = result.stream().map(o -> String.valueOf(o.c)).collect(Collectors.toList());
            LOGGER.info("LEVELS:{},需要打回的档位为:{}", LEVELS, resultList);
        }
        return resultList;
    }

    /**
     * 计算档位最大落差档位和档位和
     *
     * @param levels
     * @return
     */
    public static List<Distance> judge(char[] levels) {
        List<Distance> result = new ArrayList<>();
        for (char c : levels) {
            Distance d = new Distance(c);
            for (char other : levels) {
                int distance = Math.abs(c - other);
                d.max = Math.max(d.max, distance);
                d.sum += distance;
            }
            if (d.max >= MAX_DISTANCE && d.sum > SUM_DISTANCE) {
                result.add(d);
            }
        }
        return result;
    }

    /**
     * 档位计算类[档位，最大档位落差，最大档位落差和]
     */
    static class Distance {
        char c;
        int max;
        int sum;

        public Distance(char c) {
            this.c = c;
            this.max = 0;
            this.sum = 0;
        }

        public char getC() {
            return c;
        }

        public void setC(char c) {
            this.c = c;
        }

        public int getMax() {
            return max;
        }

        public void setMax(int max) {
            this.max = max;
        }

        public int getSum() {
            return sum;
        }

        public void setSum(int sum) {
            this.sum = sum;
        }
    }
}
